# medz/plugs/status.py
#
#

""" show version. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.utils.string import to_str
from medz.utils.time import elapsed_days, elapsed
from medz.utils.status import status, upt, waiting, name
from medz.kernel import kernel, plugs, cfg
from medz.errors import error
from medz.clock import running
from medz import __version__

import threading
import time
import medz
import os

## CMNDS

def status_usage(event):
    data = os.popen("ps -p %s -o pid,tid,class,rtprio,ni,pri,psr,rss,pcpu,stat,wchan:14,comm" % os.getpid()).read().strip()
    event.reply(str(data))

kernel.register("status.usage", status_usage)

def status_uptime(event): event.reply("uptime is %s" % elapsed_days(time.time() - kernel._start))

kernel.register("status.uptime", status_uptime)

funcs = [status, upt, waiting]

def status_ps(event):
    from medz.clock import running
    threads = [x for x in threading.enumerate() if status(x)]
    for obj in sorted(threads, key=name):
        try: o = obj.func.__self__
        except: o = obj
        res = "%s: " % name(obj)
        for func in funcs:
            a = func(o)
            if not a: continue
            try: res += "%s " % a
            except: error()
        event.reply(res)
 
kernel.register("status.ps", status_ps)
